---
name: Redux-Offline core issues template
about: Please use this template if reporting a bug

---

### Are you using `offline()` or `createOffline()` API?
_If you're using `createOffline()` API, be sure to use `compose()` in the right order._

### Store config
Please paste your config below.
```js
(Please paste your store config)
```

### Offline config

Are you using a custom configuration? If you are please paste your config below.
```js
(Please paste your offline config)
```
If you need code indentation, you can use [Prettier](https://prettier.io/playground/#N4Igxg9gdgLgprEAuEAzArlMMCW0AEAEnADYkQDqEATiQCYAUwA5tXHLlM-gLz4A6IABalyggDT5W7eHV74A5IKq06ghZIDOOEghjzUAQxKa4k6AFkI6UwHkAbnGriAvgEp8wflG-58OVAYAQmkOHC43YDYYdGoofCh0MhcAbm9fPz8Aeiz8ABVbABFbJHxC6AV9Gzh8akMoOggAW394tganDN19RJa+C0MYIQA6VHIafAYBoeG6huaGDwAqfABGAFEAagB2N2GYCABlGGpw5kXZuAAHEkMwOAYs-n5h57pNrJxmSUFBN3T4rUOLF4gAeOg4ez4MC3TSaAByhiacB4CmIZEoNHoCnwuBguh4wAABgBNaz4QxsfD2HDaA7UBLoJoAIyc+AAJMBGS0XESXPhLNY7I5qITBdUHE4XAA+AGZfCgzQnaDMaVc0KcZjDTQkHD3Bj4AAMklW+D2BwAqlcrk4AMKGUyLfCbKRsMJcbW6-Wrc0QAAyEAA7naHQ8PC5QVkldQVbLAX4WG7NcMEHRNBQcEMGBI-vgAPwCECF-ClRVXer4JUATwJwGAkHI1FKSn40irChcMokhcjmnLUGl+BcGT8oLgTTj-Bg6qTcDkw58MEj47j8q5DG0ulg-3jmQLgleIBHmVKgiCggXx8jEPs0rSPigLhA4hAECuuGgmmQoEpMcDAAVKQQL8UEMewIBwOhnxAZk6jAABrDhDnLMAzmQE50DMEBwlMagYH-OpmCaQxkCMEwsIAK00AAPAAhODEJgQ4kTgP1wjgUjjFMF9y2oXDkBgwxmRraBoKuU5YAzOghmQAAOY0QHEiBTAoOorgE8S4FwxxoLYABHdAcDYAjDCIkikDI7iQFMJocHQ6hMJfbQuF0ABFdAIHgezHJAGAhKkmSkAAJhfE5DB0M5bWaYiBKgaAOJfao8iEkDLLgTsgA).

### Are you reporting a bug?
If you've detected a bug and are able to reproduce it please share a code example using our [code-sandbox](https://codesandbox.io/s/8xml9l1r0j).
